<template>
  <v-row>
    <v-col>
      <div class="mb-8 w-100 d-flex justify-space-between align-center">
        <v-text-field v-model="query" placeholder="Recherche" clearable data-cy="UnitListSearchInput" density="compact"
          rounded variant="outlined" color="primary" hide-details max-width="400" bgColor="white">
          <template #append-inner v-if="!query">
            <v-icon>search</v-icon>
          </template>
        </v-text-field>

        <v-btn variant="outlined" rounded class="text-uppercase" data-cy="AddUnitBtn" @click="createUnit()">
          <v-icon left>add</v-icon>
          Ajouter une unité
        </v-btn>
      </div>

      <v-data-table :headers="headers" :items="unitsFiltered" disable-pagination hide-default-footer
        :row-props="rowDisabledClass" density="compact" loading-text="Chargement des unités ..."
        no-results-text="Aucune unité ne correspond à cette recherche"
        no-data-text="Aucune unité ne correspond à cette recherche" class="airvam-table">

        <template #item.airports="{ item }">
          <v-chip v-for="airport in item.airports" class="mr-2" :key="airport.id">
            {{ airport.oaci }}
          </v-chip>
        </template>

        <template #item.address="{ item }">
          {{ item.address1 }} {{ item.address2 }} {{ item.address3 }}
        </template>

        <template #item.actions="{ item }">
          <div class="d-flex">
            <v-btn icon size="x-small" data-cy="EditUnitBtn" @click="askEditUnit(item)" class="mr-1 action" flat>
              <v-icon>edit</v-icon>
            </v-btn>

            <v-btn icon size="x-small" class="action" data-cy="DeleteUnitBtn" @click="askActivateDeactivateUnit(item)" flat>
              <v-icon v-if="!item.disabled">delete</v-icon>
              <v-icon v-if="item.disabled">settings_backup_restore</v-icon>
            </v-btn>
          </div>
        </template>
      </v-data-table>


      <LazyAdminUnitsUnitDialog v-if="unitDialog && editedUnit" v-model="unitDialog" :unit="editedUnit"
        @confirm="createEditUnit" @close="close" />

      <LazyConfirmDialog v-if="unitDialogActivateDeactivate" v-model="unitDialogActivateDeactivate"
        :dialogText="unitDialogActivateDeactivateText" :dialogTitle="unitDialogActivateDeactivateTitle"
        @confirm="activateDeactivateUnit" @close="close" />
    </v-col>
  </v-row>
</template>

<script setup lang="ts">
import { debounce } from "../../mixins/utilsMixin";
import { Unit } from "~/dto/unit.dto";

const store = useStore();
const { units } = storeToRefs(useStore());
const { $api, $toast } = useNuxtApp();

const unitDialog = ref(false);
const unitDialogActivateDeactivate = ref(false);
const unitDialogActivateDeactivateTitle = ref('');
const unitDialogActivateDeactivateText = ref('');
const editedUnit: Ref<Unit | null> = ref(null);
const unitsFiltered: Ref<Unit[]> = ref([]);
const query = ref('');
const headers: Ref<any[]> = ref([
  { title: `Nom`, value: 'code' },
  { title: `Dénomination`, value: 'name' },
  { title: `Adresse`, value: 'address' },
  { title: `Email`, value: 'email' },
  { title: `Téléphone`, value: 'phoneNumber' },
  { title: 'Aéroports autorisés', value: 'airports' },
  { title: '', value: 'actions', sortable: false },
]);

const createUnit = () => {
  const unit = new Unit();
  askEditUnit(unit);
}

const askEditUnit = (item: Unit) => {
  editedUnit.value = JSON.parse(JSON.stringify(item));
  unitDialog.value = true;
}

const askActivateDeactivateUnit = (item: Unit) => {
  editedUnit.value = Object.assign({}, item);
  unitDialogActivateDeactivateTitle.value = item.disabled ? `Activation d'une unité` : `Désactivation d'une unité`
  unitDialogActivateDeactivateText.value = item.disabled ? `Êtes-vous sûr de vouloir ré-activer l'unité "${editedUnit.value.name}" ?` : `Êtes-vous sûr de vouloir désactiver l'unité "${editedUnit.value.name}" ?`;
  unitDialogActivateDeactivate.value = true;
}

const close = () => {
  unitDialogActivateDeactivate.value = false;
  unitDialog.value = false;
  editedUnit.value = null;
}

const createEditUnit = async () => {
  try {
    const unitReturned = editedUnit.value?.id ? await $api.unit.update(editedUnit.value, editedUnit.value.id.toString())
      : await $api.unit.create(editedUnit.value);
    await store.editList({ listName: 'units', item: unitReturned });
    $toast.success(editedUnit.value?.id ? "Unité modifiée" : "Unité créee");
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error(editedUnit.value?.id ? "Erreur lors de l'édition d'une unité" : "Erreur lors de la création d'une unité");
  }
  filter();
  close();
}

const activateDeactivateUnit = async () => {
  try {
    const unitReturned = editedUnit.value?.disabled ? await $api.unit.activate(editedUnit.value.id.toString())
      : await $api.unit.delete(editedUnit.value!.id.toString());
    await store.editList({ listName: 'units', item: unitReturned });
    $toast.success(unitReturned.disabled ? "Unité désactivé" : "Unité ré-activé");
  } catch (e) {
    // console.log(e.response?.data?.message);
    $toast.error(editedUnit.value?.disabled ? "Erreur lors de la ré-activation d'une unité" : "Erreur lors de la désactivation d'une unité");
  }
  filter();
  close();
}

const rowDisabledClass = ({ item }: { item: Unit }) => {
  return item.disabled ? { class: "disabled" } : undefined;
}

const filter = () => {
  unitsFiltered.value = [...units.value].filter(u => {
    if (!query.value || query.value === '') {
      return true;
    }
    return u.code?.toUpperCase().includes(query.value.toUpperCase())
      || u.name?.toUpperCase().includes(query.value.toUpperCase())
      || u.email?.toUpperCase().includes(query.value.toUpperCase())
  });
}

filter();

watch(query, debounce(function () {
  filter();
}, 300));

</script>
